Subject: Bug#687022: found also with libm4ri

From: Bill Allombert <[email-masked]>
Date: Mon, 23 Sep 2013 20:15:59 +0200

On Mon, Sep 23, 2013 at 04:26:28PM +0200, Niels Thykier wrote:
> > This might explain the large number of false positive for a test which is
> > marked "certain". This is a regression from previous lintian version.
> > 
> > So I think using a regexp is misguided. It would be more reliable to follow the
> > symlink.
> > 
> > Cheers,
> 
> The git history (which takes us back to 2004) shows that we have been
> using the regex-approach for the past 9 years[1].  snapshot.d.o go as
> far back as 0.9.3 (27 Oct 1998) and that version has the same regex as
> the code had in 2004.  So this "regression" must be at least 15 years
> old now. :)

I did not meant to say that using a regexp was a regression, but that
this bugreport was about a regression :)

Doing a bisection I find the first version to report a false positive for 
the pari package is lintian 2.5.7.

Indeed, the changelog says:

  * checks/shared-libs:
    + [NT] Fix false positive "dev-pkg-without-shlib-symlink"
      for shared libraries using "libtool -release X.Y".
      Thanks to Sven Joachim for the report.  (Closes: #673109)
    + [NT] Fix false positive "dev-pkg-without-shlib-symlink"
      for shared libraries installed in /lib.  Lintian now
      correctly expects the dev-symlink beneath /usr/lib.
      Thanks to Guillem Jover for the report.

So certainly the test was changed.

One other example of false positive I found is that lintian does not allow 
usr/lib/libfoo.so -> usr/lib/x86_64-linux-gnu/libfoo.so.X.Y.Z
which happens in multiarch transition.

Cheers,
Bill.